#!/usr/local/bin/perl
#=========================================
#    n01_webpCGI (2009/07/25)
#
#    Copyright (C) 1996-2009 by Nakashima Tomoaki. All rights reserved.
#        http://www.nakka.com/
#        nakka@nakka.com
#=========================================

#=========================================
# [ ݒu ] ̓p[~bV
#
#    public_html / index.html (z[y[W)
#       |
#       +-- n01 / n01.cgi      [705]
#            |    jcode.pl     [604]
#            |
#            +-- n01_log       [666]
#=========================================

require './jcode.pl';

$filename = $ENV{'SCRIPT_NAME'};
$ENV{'TZ'} = "JST-9";

# HTML̃^Cg
$html_title = "Result";

# ʏo̓t@C
$result_file = 'result.html';

# SetPʂŏWvꍇ 1ALegPʂŏWvꍇ 0
$set_mode = 0;

#WvΏۂƂŏLeg
$min_leg = 1;

# Ot@C̃fBNg
$logdir = 'n01_log';

#=========================================

&decode;

# CSV̕ۑ
&save_result;

# HTML̍쐬
&create_html;

exit;

#-------------------------------------------------
#  tH[fR[h
#-------------------------------------------------
sub decode {
	local($buf, $key, $val);
	undef(%in);

	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
	} else {
		$buf = $ENV{'QUERY_STRING'};
	}

	foreach (split(/&/, $buf)) {
		($key, $val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;

		$in{$key} .= "\0" if (defined($in{$key}));
		$in{$key} .= $val;
	}
}

#----------------------------------------------------------------------------
# CSV̕ۑ
#----------------------------------------------------------------------------
sub save_result {

	# CSV擾
	local($csv) = $in{'csv'};
	local($set) = $in{'set'};
	local($file_name);

	
	if ($csv ne "") {
		local(@DATA) = $csv;
		local(@head) = split("\n", $DATA[0]);
		$file_name = $head[0];

		$file_name =~ s/[\/\:]//g;
		$file_name =~ s/[\r\n]//g;
		$file_name =~ s/([^\w ])/'%'.unpack('H2', $1)/eg;
		$file_name =~ tr/ /+/;
		$file_name =~ s/%2[cC]/_/g;
		$file_name = $file_name;

		if ($file_name ne "") {
			# t@Cւ̏
			open(OUT, "> $logdir/$file_name.csv");
			flock(OUT, 2);
			print OUT $set."\n";
			print OUT $csv;
			flock(OUT, 8);
			close(OUT);
		}
	}

	print "Content-type: text/html\n\n";
}

#----------------------------------------------------------------------------
# HTML̍쐬
#----------------------------------------------------------------------------

@vs_list;
%set_count;
%name_list;
%date_list;
%set_list;
%leg_list;
%score_list;
%darts_list;

sub create_html {
	local($filename);
	local($path) = $logdir;
	local(@file_list);

	# t@Cꗗ̎擾
	opendir DHandle, $path or die "$dir:$!";
	while ($filename = readdir DHandle) {
		if ($filename =~/(?:.*.csv)/){
			push(@file_list, $filename);
		}
	}
	closedir DHandle;

	# t@Cꗗ̃\[g
	@file_list = sort @file_list;
	# CSV擾
	foreach (@file_list) {
		get_player_info($_);
	}

	open(OUT, "> $result_file");
	flock(OUT, 2);

print OUT <<EOM;
<html><head>
<title>$html_title</title>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
</head><body>
<center><table border="0" width="60%" cellpadding="0" cellspacing="0" align="center">
<tr><td>
<center>$html_title</center>
<hr noshade/>
EOM
	foreach (@vs_list) {
		@name = split(/\t/, $name_list{$_});
		@set = split(/\t/, $set_list{$_});
		@score = split(/\t/, $score_list{$_});
		@darts = split(/\t/, $darts_list{$_});

		if ($darts[0] > 0) {
			$score[0] = sprintf ("%.2f",$score[0] / $darts[0]);
		}
		if ($darts[1] > 0) {
			$score[1] = sprintf ("%.2f",$score[1] / $darts[1]);
		}

print OUT <<EOM;
<table border="0" width="0" cellpadding="5" cellspacing="0" align="center">
<tr><td colspan="5">$date_list{$_}</td></tr>
<tr><td width="100" align="right">$name[0]<br/>($score[0])</td>
<td width="30" align="center">$set[0]</td>
<td>-</td>
<td width="30" align="center">$set[1]</td>
<td width="100" align="left">$name[1]<br/>($score[1])</td></tr>
EOM

		if ($set_mode == 1) {
print OUT <<EOM;
<tr><td colspan="5" align="center">[Legs]<BR>$leg_list{$_}</td></tr>
EOM
		}

print OUT <<EOM;
</table>
<hr noshade/>
EOM
	}
print OUT <<EOM;
</td></tr></table></center>
</body></html>
EOM
	flock(OUT, 8);
	close(OUT);
}

#----------------------------------------------------------------------------
# vC[̎擾
#----------------------------------------------------------------------------
sub get_player_info {
	local($filename) = $_[0];

	# t@C̓ǂݍ
	open(IN, "$logdir/$filename");
	flock(IN, 1);
	@DATA = <IN>;
	flock(IN, 8);
	close(IN);

	chomp $DATA[0];
	chomp $DATA[1];
	chomp $DATA[2];
	chomp $DATA[3];
	chomp $DATA[25];
	chomp $DATA[26];

	@vs_data = split(",", $DATA[1]);
	$vs_name = $vs_data[1]."-".$vs_data[3];

	if ($DATA[0] == 0) {
		if (exists($set_count{$vs_name})) {
			$set_count{$vs_name} = $set_count{$vs_name} + 1;
		} else {
			$set_count{$vs_name} = 0;
		}
	}
	$vs_name = $vs_name."_".$set_count{$vs_name};

	local(@set);
	local(@score);
	local(@darts);
	if (exists($name_list{$vs_name})) {
		@set = split(/\t/, $set_list{$vs_name});
		@score = split(/\t/, $score_list{$vs_name});
		@darts = split(/\t/, $darts_list{$vs_name});
	} else {
		unshift(@vs_list, $vs_name);
		$date_list{$vs_name} = $vs_data[0];
		$date_list{$vs_name} =~ s/\:[0-9][0-9]$//g;
		@set = (0, 0);
		@score = (0, 0);
		@darts = (0, 0);
	}

	if ($set_mode == 1) {
		# Set̎擾
		@set_data = split(",", $DATA[2]);
		# Leg̎擾
		@leg_data = split(",", $DATA[3]);
		if ($leg_data[2] >= $min_leg || $leg_data[4] >= $min_leg) {
			$set[0] = $set[0] + $set_data[2];
			$set[1] = $set[1] + $set_data[4];
		}
		$leg_list{$vs_name} = $leg_list{$vs_name}.$leg_data[2]." - ".$leg_data[4]."<BR>"
	} else {
		# Leg̎擾
		@set_data = split(",", $DATA[3]);
		$set[0] = $set[0] + $set_data[2];
		$set[1] = $set[1] + $set_data[4];
	}

	# score̎擾
	@score_data = split(",", $DATA[25]);
	$score[0] = $score[0] + $score_data[2];
	$score[1] = $score[1] + $score_data[4];

	# darts̎擾
	@darts_data = split(",", $DATA[26]);
	$darts[0] = $darts[0] + $darts_data[2];
	$darts[1] = $darts[1] + $darts_data[4];

	$name_list{$vs_name} = $vs_data[1]."\t".$vs_data[3];
	$set_list{$vs_name} = join("\t", @set);
	$score_list{$vs_name} = join("\t", @score);
	$darts_list{$vs_name} = join("\t", @darts);
}
__END__
